#/bin/bash
set -eu -o pipefail # See: https://sipb.mit.edu/doc/safe-shell/

find $PWD -regex ".*\.[hcHC]\(pp\|xx\)?" | \
    grep -v " \|/generated/" > cscope.files

# -b = Build database.
# -q = Enable fast symbol lookup via an inverted index.
# -R = (Instead of using cscope.files) Recurse subdirectories.
# -k = Kernel mode. (Ignore /usr/include)
cscope -q -b -k

echo "You can now use \`cscope -d\`  # Run cscope without updating cross reference"
